
/****************************************************************

  File name   :  common.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

#ifndef __common_H__
#define __common_H__

// --------------------------------------------------------------------------------------

#include "value_node.h"
#include "const_value.h"
#include "operator.h"

// --------------------------------------------------------------------------------------

#define SUB_EXPRESSION_MAX_LENGTH   256         // ӱʽ󳤶
#define MAX_WORD_LENGTH             64          // һʵ󳤶
#define MAX_BRACKET_SIZE            32          // ŵǶ

// --------------------------------------------------------------------------------------

namespace Why
{

// ǷΪ
unsigned int IsLeftBracketLetter(char c);

// ǷΪ
unsigned int IsRightBracketLetter(char c);

// 
const Operator* GetLeftBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index);

// 
const Operator* GetRightBracketOperator(const char* szExpression, unsigned int& pos, unsigned int& index);

// ұ׼Ŀ
const Operator* GetStandardSingleOperator(const char* szExpression, unsigned int& pos);

// ұ׼˫Ŀ
const Operator* GetStandardTwinOperator(const char* szExpression, unsigned int& pos);

// ȡʽеǰĴ
bool GetWord(char* szWord, const char* szExpression, unsigned int& pos);

// Ҷ
bool GetCommaOperator(const char* szExpression, unsigned int& pos);

// ҵȺ
bool GetEqualOperator(const char* szExpression, unsigned int& pos);

// ð
bool GetColonOperator(const char* szExpression, unsigned int& pos);

// Ҳa-z
char GetParameter(const char* szWord);

// ȡֵ
bool GetFloatValue(const char* szWord, float& rst);

// ȡֵ
bool GetIntegerValue(const char* szWord, float& rst);

// ȡֵ
bool GetIntegerValue(int& rst, const char* szExpression, unsigned int& pos);

// ѧʽĸ
bool GetScientificFloat(float& rst, const char* szExpression, unsigned int& pos);

};

// --------------------------------------------------------------------------------------

#endif // __common_H__
