
/****************************************************************

  File name   :  const_value.cpp
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

// --------------------------------------------------------------------------------------

#include <string.h>
#include "const_value.h"
#include "misc.h"

// --------------------------------------------------------------------------------------

#pragma warning(disable: 4996)
namespace Why
{

// --------------------------------------------------------------------------------------

// 

ConstValue   g_arrayConstValues[CONST_VALUES_COUNT] = {0};
unsigned int g_countConstValues = 0;

// --------------------------------------------------------------------------------------

// ʼ
void InitConstValue()
{
    strcpy(g_arrayConstValues[0]._szName, "PI"); 
    g_arrayConstValues[0]._hash = get_string_hash(g_arrayConstValues[0]._szName);
    g_arrayConstValues[0]._value = REAL_PI;

    strcpy(g_arrayConstValues[1]._szName, "E"); 
    g_arrayConstValues[1]._hash = get_string_hash(g_arrayConstValues[1]._szName);
    g_arrayConstValues[1]._value = REAL_E;

    if (g_countConstValues == 0)
    {
        g_countConstValues = 2;
    }
}

// ӻóֵ
bool SetConstValue(const char* szName, float value)
{
    if (!szName || !szName[0])
    {
        return false;
    }

    size_t len = strlen(szName);
    if (len >= CONST_VALUE_NAME_LENGTH)
    {
        return false;
    }

    unsigned int hash = get_string_hash(szName);

    unsigned int i = 0;
    for (i = 0; i < g_countConstValues; i++)
    {
        if (g_arrayConstValues[i]._hash == hash &&
            strcmp(g_arrayConstValues[i]._szName, szName) == 0)
        {
            break;
        }
    }

    if (i >= CONST_VALUES_COUNT)
    {
        return false;
    }

    g_arrayConstValues[i]._hash = hash;
    strcpy(g_arrayConstValues[i]._szName, szName);

    if (i == g_countConstValues)
    {
        g_countConstValues++;
    }

    return true;
}

// ݳȡֵ
bool GetConstValue(const char* szName, float& value)
{
    if (g_countConstValues == 0)
    {
        InitConstValue();
    }

    if (!szName || !szName[0])
    {
        return false;
    }

    size_t len = strlen(szName);
    if (len >= CONST_VALUE_NAME_LENGTH)
    {
        return false;
    }

    unsigned int hash = get_string_hash(szName);

    for (unsigned int i = 0; i < g_countConstValues; i++)
    {
        if (g_arrayConstValues[i]._hash == hash &&
            strcmp(g_arrayConstValues[i]._szName, szName) == 0)
        {
            value = g_arrayConstValues[i]._value;
            return true;
        }
    }

    value = 0.0f;
    return false;
}

};

// --------------------------------------------------------------------------------------
