
/****************************************************************

  File name   :  misc.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :  
  Others      :  

*****************************************************************/

#ifndef __misc_H__
#define __misc_H__

// --------------------------------------------------------------------------------------

#define REAL_PI         3.14159265358979f       // Բ
#define REAL_E          2.71828182845905f       // e

// --------------------------------------------------------------------------------------

namespace Why
{

// ǷΪСдĸ
inline bool is_small_letter(char c)
{
    return c >= 'a' && c <= 'z';
}

// ǷΪдĸ
inline bool is_big_letter(char c)
{
    return c >= 'A' && c <= 'Z';
}

// ǷΪ
inline bool is_number(char c)
{
    return c >= '0' && c <= '9';
}

// ǷΪָ
inline bool is_separator(char c)
{
    return (' ' == c || 0 == c || ',' == c || '/t' == c || ':' == c ||
            '(' == c || ')' == c || '[' == c || ']' == c || '{' == c || '}' == c || '<' == c || '>' == c || 
            '+' == c || '-' == c || '*' == c || '/' == c || '%' == c || '^' == c || '=' == c);
}

// --------------------------------------------------------------------------------------

// ַHASHֵ
unsigned int    get_string_hash(const char *str);

// ַת,֧2,8,10,16ֽ
/*
    0XͷΪ16, XABCDEFСд, 0xffff   
    0YͷΪ2, YСд, 0y10101010000
    0ͷΪ8, 07523, ע"08"֮ʧ
    ĬΪ10
*/
bool            string_to_int(const char* szSrc, int& rst);

// תΪһƵַ
void            int_to_string(int value, char* szDest, int type = 10);

};

// --------------------------------------------------------------------------------------

#endif // __misc_H__
