
/****************************************************************

  File name   :  value_node_operate.h
  Author      :  Ҷ
  Version     :  1.0a
  Create Date :  2014/06/18 
  Description :   
  Others      :  

*****************************************************************/

#ifndef __value_node_operate_H__
#define __value_node_operate_H__

// --------------------------------------------------------------------------------------

#include "value_node.h"
#include "operator.h"

// --------------------------------------------------------------------------------------

namespace Why
{

void ValueNodeSingleOperate(
    SINGLE_OPERATOR_FUNC single_func, 
    ValueNode* pOut, 
    const ValueNode* p);

void ValueNodeTwinOperate(
    TWIN_OPERATOR_FUNC twin_func, 
    ValueNode* pOut, 
    const ValueNode* p1, 
    const ValueNode* p2);

void ValueNodeThreeOperate(
    THREE_OPERATOR_FUNC three_func, 
    ValueNode* pOut, 
    const ValueNode* p1, 
    const ValueNode* p2, 
    const ValueNode* p3);

void ValueNodeFourOperate(
    FOUR_OPERATOR_FUNC four_func,
    ValueNode* pOut, 
    const ValueNode* p1, 
    const ValueNode* p2, 
    const ValueNode* p3,
    const ValueNode* p4);

};

// --------------------------------------------------------------------------------------

#endif // __value_node_operate_H__
